# -*- coding: utf-8 -*-

from flask import Blueprint, Flask, request, flash, render_template, url_for, session, redirect, abort, make_response, send_file, escape, flash, abort
from werkzeug import secure_filename
from wand.image import Image
import time
import sqlite3
import os




filesupload = Blueprint('filesupload', __name__, template_folder='templates')

DOSSIER_PERSO='users/'
extensionimg = {'.jpg', '.JPG', '.png', '.PNG', '.gif', '.GIF', '.bmp', '.BMP', '.jpeg', '.JPEG' }

@filesupload.route( '/upload/', methods=['GET', 'POST'])
def upload():
    if 'username' in session :
       UTILISATEUR='%s'% escape(session['username'])
       if request.method == 'POST' :
           files = request.files.getlist('fic')
           for f in files :
              if f: # On vérifie qu'un fichier a bien été envoyé
                 nom = secure_filename(f.filename)
                 if os.path.isfile(DOSSIER_PERSO + UTILISATEUR + '/files/' + nom):
                    flash(u'Fichier déjà existant, merci de spécifier un autre nom de fichier', 'error')
                 else:
                    if os.path.isfile(DOSSIER_PERSO + UTILISATEUR + '/images/' + nom):
                       flash(u'Image déjà existante, merci de spécifier un autre nom de fichier', 'error')
                    else:
                          file, ext = os.path.splitext(nom)
                          if ext in extensionimg :
                             f.save(DOSSIER_PERSO + UTILISATEUR + '/images/' + nom)
                             image=DOSSIER_PERSO + UTILISATEUR + '/images/' + nom
                             with Image(filename=image) as img :
                                 img.transform(resize='x100')
                                 img.save(filename=DOSSIER_PERSO + UTILISATEUR + '/images/thumbnails/' + nom)
                             if os.path.isfile(DOSSIER_PERSO + UTILISATEUR + '/images/' + nom) :
                                if os.path.isfile(DOSSIER_PERSO + UTILISATEUR + '/images/thumbnails/' + nom):
                                   TIME=time.strftime("%A %d %B %Y %H:%M:%S")
                                   IP=request.environ['REMOTE_ADDR']
                                   CLIENT_PLATFORM=request.headers.get('User-Agent')
                                   LOG=open("log.txt", "a")
                                   LOG.write (TIME + ' - ' + IP + ' - ' + UTILISATEUR + ' - ' + CLIENT_PLATFORM + '\n' + '---> ' + nom + '\n')
                                   LOG.close()
                                   flash(u'Image envoyée et traitée avec succés', 'succes')
                                else:
                                   flash(u'Échec lors du traitement de l\'image', 'error')
                                   return redirect(url_for('filesupload.upload'))
                             else:
                                flash(u'Éches lors de l\'envoi de l\'image', 'error')
                                return redirect(url_for('filesupload.upload'))
                          else:
                             f.save(DOSSIER_PERSO + UTILISATEUR + '/files/' + nom)
                             if os.path.isfile(DOSSIER_PERSO + UTILISATEUR + '/files/' + nom) :
                                TIME=time.strftime("%A %d %B %Y %H:%M:%S")
                                IP=request.environ['REMOTE_ADDR']
                                CLIENT_PLATFORM=request.headers.get('User-Agent')
                                LOG=open("log.txt", "a") # Ouvre fichier log.txt
                                LOG.write (TIME + ' - ' + IP + ' - ' + UTILISATEUR + ' - ' + CLIENT_PLATFORM + '\n' + '---> ' + nom + '\n') # Écrit dans log
                                LOG.close() # Ferme log.txt
                                flash(u'Fichier envoyé avec succés', 'succes')
                                #return redirect(url_for('filesupload.upload'))
                             else:
                                return redirect(url_for('filesupload.upload'))
              else:
                 flash(u'Error : Vous avez oublié le fichier !', 'error')
                 return redirect(url_for('filesupload.upload'))
       resp = make_response(render_template('up_up.html'))
       resp.set_cookie('username', session['username'])
       return resp
    else :
       return redirect(url_for('loginlogout.login', _external=True))

@filesupload.route('/view/')
def list():
    if 'username' in session :
        UTILISATEUR='%s'% escape(session['username'])
        i = 0
        fichiers = os.listdir(DOSSIER_PERSO + UTILISATEUR + '/files/')
        listeFichiers = []
        if fichiers:
            for fich in fichiers:
                i += 1
                size = os.path.getsize(DOSSIER_PERSO + UTILISATEUR + '/files/' + fich) # size = taille des fichiers
                listeFichiers.append([i, fich, size]) # On implémente la listeFichiers avec le num le ficier et sa taille
            return render_template('up_list.html',size=size, i=i, listeFichiers=listeFichiers)
        else :
            flash(u'Aucun fichier uploadé ! Redirection vers Upload', 'error')
            return redirect(url_for('filesupload.upload', external=True))
    else :
        return redirect(url_for('loginlogout.login', _external=True))
